Public Class FormSensorOptions

    Private Sub FormSensorOptions_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For Each PortName As String In My.Computer.Ports.SerialPortNames
            Me.ComboBoxPortName.Items.Add(PortName)
        Next

        Me.ComboBoxPortName.SelectedItem = My.Settings.SensorPortName
        Me.TextBoxUpdateInterval.Text = CStr(My.Settings.SensorUpdateInterval / 1000)
        Me.TextBoxTimeout.Text = CStr(My.Settings.SensorTimeout / 1000)
    End Sub

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        Dim SensorUpdateInterval, SensorTimeout As Int32

        If Not Int32.TryParse(Me.TextBoxUpdateInterval.Text, SensorUpdateInterval) Or SensorUpdateInterval < 1 Or SensorUpdateInterval > 3600 Then
            MsgBox("Update interval must be integer between 1 and 3600 seconds", MsgBoxStyle.Exclamation)
            Me.TextBoxUpdateInterval.Focus()
            Return
        ElseIf Not Int32.TryParse(Me.TextBoxTimeout.Text, SensorTimeout) Or SensorUpdateInterval < 1 Or SensorUpdateInterval > 60 Then
            MsgBox("Timeout must be integer between 1 and 60 seconds", MsgBoxStyle.Exclamation)
            Me.TextBoxTimeout.Focus()
            Return
        End If

        My.Settings.SensorPortName = Me.ComboBoxPortName.SelectedItem.ToString()
        My.Settings.SensorTimeout = SensorTimeout * 1000
        My.Settings.SensorUpdateInterval = SensorUpdateInterval * 1000
        My.Settings.Save()

        Me.DialogResult = Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub
End Class
