Public Class FormServiceOptions

    Private Sub FormServiceOptions_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.TextBoxUrl.Text = My.Settings.LocalClient_GlobalWeather_GlobalWeather
        Me.TextBoxWebLocationCode.Text = My.Settings.ServiceLocationCode
        Me.TextBoxUpdateInterval.Text = CStr(My.Settings.ServiceUpdateInterval \ 1000)
    End Sub

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        ' Validate settings
        Try
            Dim StationsWS As New GlobalWeather.StationInfo()
            StationsWS.Url = Me.TextBoxUrl.Text
            If Not StationsWS.isValidCode(Me.TextBoxWebLocationCode.Text) Then
                MsgBox(Me.TextBoxWebLocationCode.Text & " is not valid airport code", MsgBoxStyle.Exclamation)
                Me.TextBoxWebLocationCode.Focus()
                Return
            End If
        Catch ex As Exception
            MsgBox("Cannot communicate with web service. URL is probably invalid.", MsgBoxStyle.Exclamation)
            Me.TextBoxUrl.Focus()
            Return
        End Try

        Dim UpdateInterval As Int32
        If Not Int32.TryParse(Me.TextBoxUpdateInterval.Text, UpdateInterval) Then
            MsgBox("Update interval must be integer between 30 and 3600 seconds.", MsgBoxStyle.Exclamation)
            Me.TextBoxUpdateInterval.Focus()
            Return
        ElseIf UpdateInterval < 30 Or UpdateInterval > 3600 Then
            MsgBox("Update interval must be between 30 and 3600 seconds.", MsgBoxStyle.Exclamation)
            Me.TextBoxUpdateInterval.Focus()
            Return
        End If

        ' Save settings
        My.Settings.ServiceLocationCode = Me.TextBoxWebLocationCode.Text
        My.Settings.LocalClient_GlobalWeather_GlobalWeather = Me.TextBoxUrl.Text
        My.Settings.ServiceUpdateInterval = UpdateInterval * 1000
        My.Settings.Save()

        ' Close window
        Me.DialogResult = Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub ButtonCheckCode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCheckCode.Click
        Dim StationWS As New GlobalWeather.StationInfo()
        Dim Station As GlobalWeather.Station = StationWS.getStation(Me.TextBoxWebLocationCode.Text)
        If Station Is Nothing Then
            MsgBox("Location not found - check code", MsgBoxStyle.Exclamation)
        Else
            MsgBox(String.Format("{0} is {1}, {2}", Me.TextBoxWebLocationCode.Text, Station.name, Station.country), MsgBoxStyle.Information)
        End If
        StationWS.Dispose()
    End Sub
End Class
